/****************************************************************************/
//                      PRIMES GENERATOR V 1.1                              //
//                                                                          //
// primes.c  trouve les nombres 1ers, fait pour les cours de SPE Maths      //
//                                                                          //
//    2 modes :                                                             //
//     - prime(A)   : rpond vrai si A est un nombre premier                //
//     - prime(A,B) : trouve tous les nombres 1ers compris entre A et B     //
//                                                                          //
//    compil avec tigcc. il faut attacher longdiv.o et longmul.o           //
//    command line : tigcc primes.c -02 longdiv.o longmul.o                 //
//                                                                          //
//  Stanowski Etienne                                                       //
//  Si vous avez des commentaires : Stan.Etienne@caramail.com               //
//                                                                          //
/****************************************************************************/

// all comments will be in French, i'm sorry for english speaking peoples


#define RETURN_VALUE        // renvoie une valeur dans le stack
#define OPTIMIZE_ROM_CALLS  // optimize les rom calls et rduit le code

#include <nostub.h>         // compile en mode nostub.h
#include <args.h>           // arguments rentrs
#include <estack.h>         // fonctions pour renvoyer un rsultat
#include <statline.h>       // message d'erreur

int _ti89;                  // Compile pour la ti89
int _ti92plus;              // Compile pour la ti92+

typedef unsigned char Byte;
typedef unsigned long LongInt;

/****************************************************************************/
//------------------------------- FUNCTION ---------------------------------//
/****************************************************************************/

Byte IsItPrime(LongInt Nbr) // nombre premier ? TRUE/FALSE
{
  LongInt x;
  if (Nbr < 2) return FALSE;
  for (x = 2; x*x <= Nbr; x++)
   if (Nbr % x == 0) return FALSE;
  return TRUE;
}

/****************************************************************************/
//----------------------------- MAIN FUNCTION ------------------------------//
/****************************************************************************/

void _main(void)
{
  ESI ArgPtr;           // pointeur vers les arguments entrs
  Byte NumArgs;         // sauve le nombre d'arguments entrs

  InitArgPtr(ArgPtr);   // initialise le pointeur

  NumArgs = ArgCount(); // donne le nbr d'arguments entrs

/* vrifie que les bons arguments ont t entrs */

  if (NumArgs > 2 || GetArgType(ArgPtr) != POSINT_TAG || (NumArgs == 2 ? GetArgType(EX_getArg(1)) != POSINT_TAG : 0))
  {
    ST_helpMsg("Error! Usage: primes(num1,[num2])");
    push_END_TAG();
    push_quantum_pair(0x01,0xEC);
    return;
  }

/* les bons arguments sont entrs */

  else
  {
  // sauve le premier argument
    LongInt Num1 = (LongInt) GetIntArg(ArgPtr);
  // prpare la rponse
    push_END_TAG();

/* si un seul argument est entr */

    if (NumArgs == 1)
    {
      if (IsItPrime(Num1) == TRUE) push_quantum(TRUE_TAG);
      else push_quantum(FALSE_TAG);
    }
    else

/* si 2 arguments ont t entrs */

    {
  // sauve le deuxieme argument
      LongInt i, Num2 = (LongInt) GetIntArg(ArgPtr);
      for (i = Num2; (Num1 < Num2 ? i >= Num1 : i <= Num1); (Num1 < Num2 ? i-- : i++))
        if (IsItPrime(i) == TRUE) push_longint(i);
  // renvoie un rsultat sous forme de liste
      push_LIST_TAG();
    }
  // fin du programme
  return;
  }
}

/****************************************************************************/
//------------------------------ END OF FILE -------------------------------//
/****************************************************************************/
